package com.huimv.eartag2.manage2.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.eartag2.common.utils.DateUtil;
import com.huimv.eartag2.common.utils.Result;
import com.huimv.eartag2.common.utils.ResultCode;
import com.huimv.eartag2.manage2.mapper.BaseFarmMapper;
import com.huimv.eartag2.manage2.mapper.BaseFarmerMapper;
import com.huimv.eartag2.manage2.mapper.EartagEartagRegister2Mapper;
import com.huimv.eartag2.manage2.pojo.BaseFarm;
import com.huimv.eartag2.manage2.pojo.BaseFarmer;
import com.huimv.eartag2.manage2.pojo.EartagAbnormalAlarm;
import com.huimv.eartag2.manage2.mapper.EartagAbnormalAlarmMapper;
import com.huimv.eartag2.manage2.pojo.EartagEartagRegister2;
import com.huimv.eartag2.manage2.service.EartagAbnormalAlarmService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.util.*;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-08-30
 */
@Service
public class EartagAbnormalAlarmServiceImpl extends ServiceImpl<EartagAbnormalAlarmMapper, EartagAbnormalAlarm> implements EartagAbnormalAlarmService {
    @Autowired
    private EartagAbnormalAlarmMapper eartagAbnormalAlarmMapper;
    @Override
    public Result getEarTemWarning(Map<String, Object> paramsMap) throws ParseException {
        DateUtil dateUtil = new DateUtil();
        String farmCode = paramsMap.get("areaId")+"";
        java.sql.Date todayDate = new java.sql.Date(new java.util.Date().getTime());
        QueryWrapper<EartagAbnormalAlarm> queryWrapper = new QueryWrapper();
        queryWrapper.eq("farm_code",farmCode);
        //-测试
//        queryWrapper.eq("add_date","2022-08-22");
        queryWrapper.eq("add_date",todayDate);
        queryWrapper.eq("alarm_from","2");
        queryWrapper.eq("alarm_type","2");
        queryWrapper.orderByDesc("add_time");
        List<EartagAbnormalAlarm> eartagAbnormalAlarmList =  eartagAbnormalAlarmMapper.selectList(queryWrapper);
        JSONArray newJa = new JSONArray();
        for(EartagAbnormalAlarm eartagAbnormalAlarm:eartagAbnormalAlarmList){
            JSONObject newJo = new JSONObject();
            newJa.add(newJo);
            newJo.put("addTime",dateUtil.formatDatetimeText(eartagAbnormalAlarm.getAddTime()));
            newJo.put("content",eartagAbnormalAlarm.getContent());
        }
        return new Result(ResultCode.SUCCESS,newJa);
    }
    @Autowired
    private EartagEartagRegister2Mapper eartagEartagRegister2Mapper;

    @Autowired
    private BaseFarmerMapper baseFarmerMapper;

    @Autowired
    private BaseFarmMapper baseFarmMapper;


    @Override
    public Result getNewPig(Map<String, String> paramsMap) {
        String areaId = paramsMap.get("areaId");
        QueryWrapper<EartagEartagRegister2> wrapper = new QueryWrapper<>();

        List endList = new ArrayList();
        Date now = new Date();

        for (int i = 0 ; i<6 ;i++){
            DateTime beginOfMonth = cn.hutool.core.date.DateUtil.beginOfMonth(now);
            wrapper.clear();
            wrapper.eq("farm_id",areaId);

            beginOfMonth = cn.hutool.core.date.DateUtil.offsetMonth(beginOfMonth,-i);
            DateTime endOfMonth = cn.hutool.core.date.DateUtil.endOfMonth(beginOfMonth);
            wrapper.between("first_time",beginOfMonth,endOfMonth);
            Long release = eartagEartagRegister2Mapper.selectCount(wrapper);
            wrapper.clear();
            wrapper.eq("farm_id",areaId);
            wrapper.between("first_time",cn.hutool.core.date.DateUtil.offsetMonth(beginOfMonth,-6),cn.hutool.core.date.DateUtil.offsetMonth(endOfMonth,-6));
            Long slaughter = eartagEartagRegister2Mapper.selectCount(wrapper);

            Map map  = new HashMap();
            map.put("release",release);
            map.put("slaughter",slaughter);
            map.put("month",(cn.hutool.core.date.DateUtil.month(beginOfMonth) +1) +"月");
            endList.add(map);


        }

        return new Result(ResultCode.SUCCESS,endList);
    }

    @Override
    public Result listFarmer() {
        List<BaseFarmer> farmers = baseFarmerMapper.selectList(null);
        List endList = new ArrayList<>();
        for (BaseFarmer farmer : farmers) {
            BaseFarm baseFarm = baseFarmMapper.selectOne(new QueryWrapper<BaseFarm>().eq("farm_code", farmer.getFarmCode()));

            Map map  = new HashMap();
            map.put("farmCode",farmer.getFarmCode());
            map.put("farmerName",farmer.getFarmer());
            map.put("id",farmer.getId());
            if(ObjectUtil.isNotEmpty(baseFarm)){

                map.put("areaCode",baseFarm.getAreaCode());
                map.put("farmName",baseFarm.getFarmName());
            }else {
                map.put("areaCode","");
                map.put("farmName","");
            }


            endList.add(map);

        }
        return new Result(ResultCode.SUCCESS,endList);
    }


}
